#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use LWP::Simple;


&get_setup;
fmspm::check_spamb("modify3.cgi", "header", "$data_dir");
$q = CGI->new;

#################

$default_permissions = 0777;

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") { &start; } 



sub start
{

$gsettings = new_gsettings tseek;

$cid = $q->param('cid'); $cid =~ s/[^0-9]//g;
$lnkid = $q->param('id'); $lnkid =~ s/[^0-9]//g;
$lnkpassword = $q->param('lnkpassword');

if ($lnkid eq "") { &display_modify_problem("There is a problem with the 'Modify' template. LINK ID required inside template as hidden variable. Please inform the webmaster."); }
if ($cid eq "") { &display_modify_problem("There is a problem with the 'Modify' template. CATEGORY ID required inside template as hidden variable. Please inform the webmaster."); }


### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$modify_etxt = pseek::get_file_contents("$data_dir/modify2.txt");
@mtext = split (/\n/, $modify_etxt);



if (($gsettings->{modif_password} ne "No") and ($gsettings->{addurl_reg_system} ne "Yes"))
{
### CHECK PASSWORD
	$wsql = "SELECT * FROM links WHERE lnkid = '$lnkid' AND lnkpassword = '$lnkpassword'";
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $wsql";}
	$rows = $sth->rows();

	if ($rows < 1)
		{
		##### 0 The password you entered was incorrect.
		$error_text = $mtext[0];
		}
}


#### CHECK FOR ERRORS

$addurltext = pseek::get_file_contents("$data_dir/addurl2.txt");
@ctexts = split (/\n/, $addurltext);


#### 1 Please supply a title for your link listing
if ($q->param('title') eq ""){$error_text = $mtext[1];}

#### 2 Please supply a description for your link listing.
if ($q->param('description') eq ""){$error_text = $mtext[2];}

#### 4 The description you supplied is to long.
if (length($q->param('description')) > $gsettings->{diz_chars})
	{
	$error_text = $ctexts[4];
	}

#### 3 Please supply keywords for your link listing.
if ($q->param('keywords') eq ""){$error_text = $mtext[3];}

#### 4 Please supply a URL for your link listing.

if ($gsettings->{modify_pass_check} ne "Yes") 
{
	if ($q->param('url') eq ""){$error_text = $mtext[4];}
}

#### 5 Please supply a name for your link listing.
if ($q->param('name') eq ""){$error_text = $mtext[5];}

#### 6 Please supply an email address for your link listing.
if ($q->param('email') eq ""){$error_text = $mtext[6];}

#### 7 Please supply a password for your link listing.
if (($q->param('password') eq "") and ($gsettings->{addurl_reg_system} ne "Yes")) {$error_text = $mtext[7];}


#### KEY OPERATIONS
$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$upload_key_data = pseek::get_file_contents("$data_dir/keysupl.dat");
@up_keys = split (/:-o_:/, $upload_key_data);


foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item); 

	if ($numberfield eq "Upload")
		{
		 ### CHECK REQUIRED
		 $hidind = $keyname . "_hid";
		 if (($q->param($hidind) eq "") and ($req eq "Yes") and ($q->param($keyname) eq "")) { &modify_problem_upload($keyname, "UPLOAD_REQUIRED"); } #print "Error: Value required for: $keyname"; exit; }
		
		 if ($q->param($keyname) ne "") ### IF FILE UPLOAD
			{
			  ### CHECK FILE EXTENSION, FILE SIZE, FILE TYPE & UPLOAD TEMP FILE
			  if ($q->param($keyname) ne "") {&upload_check_image($keyname, $lnkid);}
			  push (@file_uploads, $keyname);
			}
			elsif ($q->param($hidind) ne "") #### IF EXISTIG FILE STAYS UNCHANGED
			{
			  push (@old_keep_files, $keyname . "." . $q->param($hidind));
			}
		
		}
	elsif ($req eq "Yes")
		{
		if ($q->param($keyname) eq "")
			{
			##You have not completed all the required fields. Please complete the '%%extra_field%%' field.
			$error_text = $mtext[8];
			$error_text =~ s/%%extra_field%%/$description1/g;
			}
		}


	}




#### PLACE UPLOADED EXTRA FIELD FILES

foreach $uploaded_item (@file_uploads)
	{
	$oupfile_ext = &get_file_extension($q->param($uploaded_item), $uploaded_item);
	
	$tmp_up_fname = $lnkid . "_" . $uploaded_item . "." . $oupfile_ext;
	
	&mkdirps("$web_dir/imagefiles");
	&mkdirps("$web_dir/imagefiles/$lnkid");
	&mkdirps("$web_dir/edt");
	&mkdirps("$web_dir/edt/tmp");
	&mkdirps("$web_dir/edt/tmp/$lnkid");

	$up_write_file = "$web_dir/edt/tmp/$lnkid/" . $uploaded_item . "." . $oupfile_ext;
	
			open (UPLOADFILE, "$data_dir/tmp/$tmp_up_fname");
			open (UPLWRITE, "> $up_write_file");

			  binmode (UPLOADFILE);
			  binmode (UPLWRITE);
			  
			  	while (defined($line=<UPLOADFILE>))
					{
					print UPLWRITE $line;
					}
			 
			close (UPLOADFILE);
			close (UPLWRITE);
	
	unlink ("$data_dir/tmp/$tmp_up_fname");
	}




#### UPLOAD IMAGE IF A NEW IMAGE WAS SPECIFIED AND CHECK FILE SIZE

if (($q->param('image') ne "") and ($gsettings->{enable_image_uploads} eq "Yes"))
	{

		### CHECK IF UPLOAD DIR EXISTS
		$upload_dir = "$web_dir/imagefiles";
		if ((-e $upload_dir) < 1) {
		mkdir ($upload_dir, $default_permissions);
		chmod($default_permissions,"$upload_dir","$upload_dir"); }
		#############################################################
		
		$upload_filename = $q->param('image'); 
		$upload_filename =~ s/.*[\/\\](.*)/$1/;
		(@fext) = split (/\./, $upload_filename);
		$fnr = @fext;
		$fextension = $fext[$fnr -1];
		$ufname = "$web_dir/imagefiles/m_" . "$lnkid" . "." . $fextension;

		$new_image_filename = "m_" . "$lnkid" . "." . $fextension;

		### DO UPLOAD
		$upload_filehandle = $q->param('image');
		
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;		

		### CHECK FILE SIZE
		$flsize = (-s "$ufname");
		$maxfsize = $gsettings->{upload_max_filesize}; if ($maxfsize eq "") { $maxfsize = 100; }
		$maxfsize = $maxfsize * 1000;
		
		if ($flsize > $maxfsize) #### THE FILE YOU ARE TRYING TO UPLOAD IS TOO BIG (LARGER THAN THE ALLOWED FILE SIZE)
		{
		$addurltext = pseek::get_file_contents("$data_dir/addurl2.txt");
		@ctexts = split (/\n/, $addurltext);		
		
		unlink($ufname);
		$error_text = $ctexts[17];
		$fextension = "";
		}
			

	}




### CHECK RECIPROCAL LINK IF ENABLED PREMIUM
if (($q->param('premium') eq "true") and ($gsettings->{enable_reciprocal_premium} eq "Yes"))
	{
	$recip = $q->param('reciprocal');
	
	$recip_domain = &get_domain($recip);

	if ($gsettings->{reciprocal_link_back} =~ /$recip_domain/i)
		{
		$error_text = $ctexts[16];
		}
	elsif ($q->param('reciprocal') eq "")
		{
		$error_text = $ctexts[16];
		}
	else
		{
		$url_to_get = $q->param('reciprocal');
		my $recip_url_page = get($url_to_get) or $error_text = $ctexts[16];
		$reciprocal_link_back = $gsettings->{reciprocal_link_back};
		if ($recip_url_page !~ /$reciprocal_link_back/){ $error_text = $ctexts[16]; }
		}
		$recip =~ s/'/\\'/g;
	}




### CHECK RECIPROCAL LINK IF ENABLED STANDARD

if (($q->param('premium') ne "true") and ($gsettings->{enable_reciprocal} eq "Yes"))
	{
	$recip= $q->param('reciprocal');

	$recip_domain = &get_domain($recip);
	
	if ($gsettings->{reciprocal_link_back} =~ /$recip_domain/i)
		{
		$error_text = $ctexts[16];
		}
	elsif ($q->param('reciprocal') eq "")
		{
		$error_text = $ctexts[16];
		}
	else
		{
		$url_to_get = $q->param('reciprocal');
		my $recip_url_page = get($url_to_get) or $error_text = $ctexts[16];
		$reciprocal_link_back = $gsettings->{reciprocal_link_back};
		if ($recip_url_page !~ /$reciprocal_link_back/){ $error_text = $ctexts[16]; }
		}
		$recip =~ s/'/\\'/g;
	}






if ($error_text ne "")  ### IF ERROR
	{
	&display_modify_problem($error_text);
	}

########

if ($gsettings->{addurl_reg_system} eq "Yes")
	{
	$modify_template = pseek::get_file_contents("$data_dir/rgs_modify_link_success.html");
	}
	else
	{
	$modify_template = pseek::get_file_contents("$data_dir/modify_link_success.html");
	}

$modify_template =~ s/!!scripts_url!!/$script_url/g;

#########


if ($gsettings->{searchmeth} eq "fulltext")
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
	}
	else
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
	}


$modify_template =~ s/!build_url!/$web_url/g;
$modify_template =~ s/!!build_url!!/$web_url/g;




#### UPDATE CHANGES

$title = $q->param('title'); $title =~ s/'/\\'/g;
$description = $q->param('description'); $description =~ s/'/\\'/g;
$keywords = $q->param('keywords'); $keywords =~ s/'/\\'/g;
$url = $q->param('url'); $url =~ s/'/\\'/g;
$name = $q->param('name'); $name =~ s/'/\\'/g; 
$email = $q->param('email'); $email =~ s/'/\\'/g;
$password = $q->param('password'); $password =~ s/'/\\'/g;

$notes  = $q->param('notes'); $notes  =~ s/'/\\'/g;
$timep = time();



#### IF NEW IMAGE FILE WAS UPLOADED

if ($new_image_filename ne "") 
	{
	### CHECK IF AN OLD IMAGE WAS USED
	$wsql = "SELECT image FROM links WHERE lnkid = '$lnkid'";
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $wsql";}
	while ( @row = $sth->fetchrow() )
		{
		if ($row[0] ne "") { $old_img_fname = $lnkid . "." . $row[0]; }
		}
	
	$notes = $notes . ":::IMGF:::" . $new_image_filename . ":::IMGF:::" . $old_img_fname; 
	}




#### IF NO IMAGE FILE WAS UPLOADED AND THE EXISTING IMAGE WAS CHOSEN TO BE DELETED

if (($new_image_filename eq "") and ($q->param('delimgbox') eq "Y"))
	{
	### CHECK WHAT OLD IMAGE WAS IN USE
	$wsql = "SELECT image FROM links WHERE lnkid = '$lnkid'";
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $wsql";}
	while ( @row = $sth->fetchrow() )
		{
		if ($row[0] ne "") 
			{
			$old_img_fname = "$lnkid" . "." . $row[0];
			$notes = $notes . ":::IMGF:::" . "DEL" . ":::IMGF:::" . $old_img_fname; 
			}
		}
	
	}






##### KEY/FIELD OPERATIONS

foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item); 
	
	$keycrit = $q->param($keyname);

	if ($numberfield eq "Upload")
		{
		$del_cbox = $keyname . "_cbox";
		$hid_oldfile = $keyname . "_hid";
		
		   if ($keycrit ne "") ### IF FILE UPLOADED
			{
			  $file_ext_up = &get_file_extension($keycrit, $keyname);
			  $extrafield_sql = $extrafield_sql . ",$keyname" . "_cust" . " = '" . $file_ext_up . "'";
			}
			elsif ($q->param($del_cbox) eq "Y") ### IF DELETING IMAGE
			{
			  $extrafield_sql = $extrafield_sql . ",$keyname" . "_cust" . " = ''";
			}
			elsif ($q->param($hid_oldfile) ne "") ### IF KEEPING OLD UPLOADED FILE
			{
				$extrafield_sql = $extrafield_sql . ",$keyname" . "_cust" . " = '" . $q->param($hid_oldfile) . "'";
			}
			
		}
		else
		{
		$keycrit =~ s/'/\\'/g;
		$extrafield_sql = $extrafield_sql . ",$keyname" . "_cust" . " = '" . $keycrit . "'";
		}
	
	}

###### REMOVE OLD MODIFICATION RECORD OF THIS SAME LINK IF AVAILABLE
$del_sql = "DELETE FROM modified WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($del_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}


######

$msql = "INSERT INTO modified SET
													lnkid = '$lnkid',
													cid = '$cid',
													title = '$title',
													description = '$description',
													keywords = '$keywords',
													url = '$url',
													name = '$name',
													email = '$email',
													urldate = '$timep',
													lnkpassword = '$password',
													notes = '$notes'
													$extrafield_sql
													";



$sth = $dbh->prepare($msql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
$rows = $sth->rows();



#### PLACE OLD UPLOADED FILES SO THAT MODIFIED LISTING HAS OLD FILES THAT HAD NO CHANGES

foreach $kitem (@old_keep_files)
	{
		
		&mkdirps("$web_dir/edt");
		&mkdirps("$web_dir/edt/tmp");
		&mkdirps("$web_dir/edt/tmp/$lnkid");
		
		$exist_write_file = "$web_dir/edt/tmp/$lnkid/$kitem";
		
		open (EXISTINGFILE, "$web_dir/imagefiles/$lnkid/$kitem");
		open (UPLWRITE, "> $exist_write_file");
	
	   binmode (EXISTINGFILE);
	   binmode (UPLWRITE);
				  
	  	while (defined($line=<EXISTINGFILE>))
				{
				print UPLWRITE $line;
				}
				 
		close (EXISTINGFILE);
		close (UPLWRITE);

	}



#####

$modify_template =~ s/%%continue%%//gi;

#####

$sth->finish;
$dbh->disconnect;

$modify_template = pseek::ts_insert_template_includes($modify_template);
$modify_template = pseek::fill_vars($modify_template); 

clean_temp_uploaded_files; ### CLEAN TEMP UPLOADED IMAGE FILES

print $modify_template;

}



sub get_domain
{
my ($sp_url) = @_;
 
$sp_url =~ s/http:\/\/www\.//gi;
$sp_url =~ s/http:\/\///gi;
@alitems = split (/\//, $sp_url);
$realdomain = $alitems[0];

return($realdomain);
}




sub upload_check_image
{

my ($upkeyname, $mid) = @_;


foreach $upitem (@up_keys)
	{
	($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t, $filetype_error_t, $reqtext_t, $filesize_error_t) = split (/:o:-:o:/, $upitem);
	if ($fieldname_t eq $upkeyname)
		{
		## CHECK FILE EXTENSION
		&check_valid_file_types($fieldname_t, $filetypes_t);
		
		## CHECK UPLOAD SIZE
		&upload_temp_file_check_image_size($fieldname_t, $uploadsize_t, $filesize_error_t, $mid);
		}
	}



}



sub upload_temp_file_check_image_size
{
my ($up_fkey, $upsize_max, $size_error, $link_id) = @_;

### UPLOAD FILE
	$up_filename = $q->param($up_fkey);
	$file_ext_up = &get_file_extension($up_filename, $up_fkey);
		
		$ufname = "$data_dir/tmp/" . "$link_id" . "_" . $up_fkey . "." . $file_ext_up;
		$upload_filehandle = $q->param($up_fkey);
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;	

$flsize = (-s "$ufname");

if ($flsize < 1) { &modify_problem_upload($up_fkey, "WRONG_FILESIZE"); }

$upsize_max = $upsize_max * 1000;
if ($flsize > $upsize_max) { &modify_problem_upload($up_fkey, "WRONG_FILESIZE"); }

}




sub check_valid_file_types
{

my ($uptkeyname, $valid_file_types) = @_;

$up_filename = $q->param($uptkeyname);

$up_file_ext = &get_file_extension($up_filename, $uptkeyname);

$up_file_ext = "." . $up_file_ext;

if ($valid_file_types ne "*")
	{
	my @allftypes = split (/,/, $valid_file_types);
	
	$file_type_ok = "";
	foreach $fitem (@allftypes)
		{
			if ($fitem eq $up_file_ext)
				{
				$file_type_ok = "true";
				}
		}
	
	if ($file_type_ok ne "true") { &modify_problem_upload($uptkeyname, "WRONG_EXTENSION"); }
	}

}




sub get_file_extension
{
($fullnamem, $ext_keyname) = @_;

if ($fullnamem !~ /\./) { &modify_problem_upload($ext_keyname, "WRONG_EXTENSION"); }

my @fext = split (/\./, $fullnamem);
$fnr = @fext;
$ret_ext = $fext[$fnr -1];

return($ret_ext);
} 





sub modify_problem_upload
{
my ($the_p_key, $kind_of_problem) = @_;


foreach $upitem (@up_keys)
	{
	($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t, $filetype_error_t, $reqtext_t, $filesize_error_t) = split (/:o:-:o:/, $upitem);
	if ($fieldname_t eq $the_p_key)
		{
		if ($kind_of_problem eq "UPLOAD_REQUIRED") { &display_modify_problem($reqtext_t); }
		elsif ($kind_of_problem eq "WRONG_EXTENSION") { &display_modify_problem($filetype_error_t); }
		elsif ($kind_of_problem eq "WRONG_FILESIZE") { &display_modify_problem($filesize_error_t); }
		}
	}


}




sub display_modify_problem
{

my ($the_problem) = @_;

	if ($gsettings->{addurl_reg_system} eq "Yes")
		{
		$modify_template = pseek::get_file_contents("$data_dir/rgs_modify_link_problem.html");
		}
		else
		{
		$modify_template = pseek::get_file_contents("$data_dir/modify_link_problem.html");
		}
	
	$modify_template = pseek::ts_insert_template_includes($modify_template);
	$modify_template =~ s/!!scripts_url!!/$script_url/g;

if ($gsettings->{searchmeth} eq "fulltext")
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
	}
	else
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
	}

	
	$modify_template =~ s/!build_url!/$web_url/g;
	$modify_template =~ s/!!build_url!!/$web_url/g;
	$modify_template =~ s/%%problem%%/$the_problem/gi;
	$modify_template = pseek::fill_vars($modify_template); 
	print $modify_template; 

	&clean_temp_uploaded_files;
	
	exit; 
}






sub clean_temp_uploaded_files
{

opendir(DDR,"$data_dir/tmp");
@bdfiles = readdir(DDR);
closedir (DDR); 


foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item); 
	
	if ($numberfield eq "Upload")
		{
			$testfile = $lnkid . "_" . $keyname . ".";
			
			foreach $item (@bdfiles)
				{
				if (substr($item, 0, length($testfile)) eq $testfile)
					{
					unlink ("$data_dir/tmp/$item");
					}
				
				}
		}
	}

}





sub mkdirps
{
my ($dir_to_create) = @_;

if ((-e $dir_to_create) < 1) 
	{
	mkdir ($dir_to_create, $default_permissions);
	chmod($default_permissions,$dir_to_create); 
	}

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

